
package com.taobao.idlefish.flutterboost.Cache;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;

import com.taobao.idlefish.flutterboost.Cache.StackCacheIObject;
import com.taobao.idlefish.flutterboost.Cache.StackCacheObjectCallback;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class ImageCacheObject implements StackCacheIObject {

    private String mKey;
    static ExecutorService executorService = Executors.newSingleThreadExecutor();

    public Bitmap getImage() {
        return image;
    }

    public void setImage(Bitmap image) {
        this.image = image;
    }

    Bitmap image;

    @Override
    public String getKey() {
        return mKey;
    }

    @Override
    public void setKey(String key) {
        mKey = key;
    }

    @Override
    public void writeToFile(final String cacheDir, StackCacheObjectCallback callback) {

        if(cacheDir == null) return;

        executorService.execute(new Runnable() {

            @Override
            public void run() {
                File file = new File(cachePath(cacheDir));
                try {
                    BufferedOutputStream bos = new BufferedOutputStream(new FileOutputStream(file));
                    image.compress(Bitmap.CompressFormat.JPEG, 100, bos);
                    bos.flush();
                    bos.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }

        });

    }

    @Override
    public void restoreFromFile(final String cacheDir, final StackCacheObjectCallback callback) {
        if(cacheDir == null) return;

        executorService.execute(new Runnable() {
            @Override
            public void run() {
                Bitmap bitmap = BitmapFactory.decodeFile(cachePath(cacheDir));
                setImage(bitmap);
                if(callback != null){
                    callback.onFinished(null,cachePath(cacheDir));
                }
            }
        });
    }

    private String cachePath(String dirPath){

        if(dirPath == null) return "root";

        File dir = new File(dirPath);
        if(!dir.exists()){
            dir.mkdir();
        }
        return dirPath + "/" + mKey + ".jpg";
    }
}
